/*
 * FileHistoryDialog.java
 *
 * Created on 07 March 2003, 19:52
 */

package com.togethersoft.modules.p4vcs.dialogs;


import com.perforce.api.Change;
import com.perforce.api.Env;
import com.perforce.api.FileEntry;
import com.togethersoft.openapi.ide.IdeAccess;
import com.togethersoft.openapi.ide.message.IdeMessageManagerAccess;
import com.togethersoft.openapi.ide.message.IdeMessagePage;
import com.togethersoft.openapi.ide.message.IdeMessageType;
import com.togethersoft.openapi.ide.window.IdeWindowManagerAccess;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Vector;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.border.BevelBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;

/** @author  Administrator */
public class FileHistoryDialog extends JDialog
{

   /** Creates new form FileHistoryDialog */
   public FileHistoryDialog(JDialog parent, boolean modal, String fileName, Env env)
   {
      super(parent, modal);
      this.fileName = fileName;
      this.env = env;
      withBranching = false;
      messagepage = IdeMessageManagerAccess.getMessageManager().openPage("Version Control");
      String options = "-t";
      if (withBranching)
      {
         options = "-it";
      }
      Vector history = FileEntry.getVerboseFileLog(getEnv(), fileName, options);
      historyTableModel = new FileEntryTableModel(history);
      sorter = new TableSorter(historyTableModel);
      fileEntry = FileEntry.getFile(getEnv(), fileName);
      initComponents();
   }

   /**
    * This method is called from within the constructor to initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
    */
   private void initComponents()
   { //GEN-BEGIN:initComponents
      mainButtonPanel = new JPanel();
      viewButton = new JButton();
      syncButton = new JButton();
      diffRevsButton = new JButton();
      diffButton = new JButton();
      describeButton = new JButton();
      contentPanel = new JPanel();
      tablePanel = new JPanel();
      historyTable = new JTable(sorter);


      tableScrollPane = new JScrollPane(historyTable);
      actionsPanel = new JPanel();
      detailPanel = new JPanel();
      actionsLabel = new JLabel();
      fileTypeLabel = new JLabel();
      fileTypeTextField = new JTextField();
      branchCheckBox = new JCheckBox();
      actionTextArea = new JTextArea();
      changePanel = new JPanel();
      changeLabelPanel = new JPanel();
      changeLabel = new JLabel();
      changeTextArea = new JTextArea();
      buttonPanel = new JPanel();
      closeButton = new JButton();
      helpButton = new JButton();

      setModal(true);
      setTitle("Revision History for " + fileEntry.getDepotPath());
      addWindowListener(
          new WindowAdapter()
          {
             public void windowClosing(WindowEvent evt)
             {
                closeDialog(evt);
             }
          });

      mainButtonPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

      viewButton.setFont(new Font("Dialog", 0, 11));
      viewButton.setText("View");

      mainButtonPanel.add(viewButton);

      syncButton.setFont(new Font("Dialog", 0, 11));
      syncButton.setText("Sync");
      mainButtonPanel.add(syncButton);

      diffRevsButton.setFont(new Font("Dialog", 0, 11));
      diffRevsButton.setText("Diff Revs");
      diffRevsButton.setEnabled(false);
      mainButtonPanel.add(diffRevsButton);

      diffButton.setFont(new Font("Dialog", 0, 11));
      diffButton.setText("Diff vs Client File");
      mainButtonPanel.add(diffButton);

      describeButton.setFont(new Font("Dialog", 0, 11));
      describeButton.setText("Describe Changelist");
      mainButtonPanel.add(describeButton);

      getContentPane().add(mainButtonPanel, BorderLayout.NORTH);

      contentPanel.setLayout(new BorderLayout());

      contentPanel.setBorder(new EmptyBorder(new Insets(5, 5, 5, 5)));
      contentPanel.setPreferredSize(new Dimension(773, 600));
      tablePanel.setLayout(new GridLayout(1, 0));

      tablePanel.setPreferredSize(new Dimension(300, 250));
      sorter.addMouseListenerToHeaderInTable(historyTable);
      historyTable.setPreferredScrollableViewportSize(new Dimension(700, 250));
      historyTable.setBorder(new BevelBorder(BevelBorder.RAISED));
      historyTable.setShowGrid(false);
      sorter.setModel(historyTableModel);
      historyTable.setPreferredSize(new Dimension(300, 250));
      historyTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

      TableColumn column = null;
      for (int i = 0; i < 7; i++) {
         column = historyTable.getColumnModel().getColumn(i);
         if (i == 1 || i == 6) {
            column.setPreferredWidth(100);
         } else if (i == 4) {
            column.setPreferredWidth(40);
         } else {
            column.setPreferredWidth(20);
         }
      }
    
      rowSelectionModel = historyTable.getSelectionModel();
      rowSelectionModel.addListSelectionListener(
          new ListSelectionListener()
          {
             public void valueChanged(ListSelectionEvent e)
             {
                //Ignore extra messages.
                if (e.getValueIsAdjusting()) return;

                ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                if (lsm.isSelectionEmpty())
                {
                   falsifyButtons();
                }
                else
                {
                   int minSelectionIndex = lsm.getMinSelectionIndex();
                   int maxSelectionIndex = lsm.getMaxSelectionIndex();
                   int numSelected = 0;

                   actionTextArea.setText((String)sorter.getValueAt(maxSelectionIndex, 7));
                   changeTextArea.setText((String)sorter.getValueAt(maxSelectionIndex, 6));
                   //how many selected?
                   //enable/disable buttons
                  
                  selected = new ArrayList();
                  for (int i = minSelectionIndex; i <= maxSelectionIndex; i++)
                  {
                     if (lsm.isSelectedIndex(i))
                     {
                       selected.add(new Integer(i));
                       numSelected++;  
                     }
                  }
                  if (numSelected > 2)
                  {
                     falsifyButtons();
                     return;
                  }
                  if (numSelected == 2)
                  {
                     falsifyButtons();
                     diffRevsButton.setEnabled(true);
                     return;
                  }
                     enableButtons();
                     diffRevsButton.setEnabled(false);
                     String selectedDepotPath = (String)sorter.getValueAt(minSelectionIndex, 1);
                     if (!selectedDepotPath.equals(fileEntry.getDepotPath()))
                     {
                        diffButton.setEnabled(false);
                     }
                }
             }
          });
      rowSelectionModel.setSelectionInterval(0, 0);
      tablePanel.add(tableScrollPane);

      contentPanel.add(tablePanel, BorderLayout.NORTH);

      actionsPanel.setLayout(new BorderLayout());

      actionsPanel.setPreferredSize(new Dimension(576, 175));
      detailPanel.setLayout(new GridLayout(1, 0, 5, 0));

      detailPanel.setBorder(new EmptyBorder(new Insets(5, 1, 5, 1)));
      actionsLabel.setText("Actions");
      actionsLabel.setForeground(Color.black);
      actionsLabel.setFont(new Font("Dialog", 0, 11));
      detailPanel.add(actionsLabel);

      fileTypeLabel.setText("File Type");
      fileTypeLabel.setForeground(Color.black);
      fileTypeLabel.setHorizontalAlignment(SwingConstants.RIGHT);
      fileTypeLabel.setFont(new Font("Dialog", 0, 11));
      fileTypeLabel.setHorizontalTextPosition(SwingConstants.LEADING);
      detailPanel.add(fileTypeLabel);

      fileTypeTextField.setEditable(false);
      fileTypeTextField.setFont(new Font("Dialog", 0, 11));
      String fileType = fileEntry.getHeadType();
      fileTypeTextField.setText(fileType);
      fileTypeTextField.setHorizontalAlignment(JTextField.LEFT);
      fileTypeTextField.setBorder(new BevelBorder(BevelBorder.LOWERED));
      fileTypeTextField.setName("");

      detailPanel.add(fileTypeTextField);

      branchCheckBox.setFont(new Font("Dialog", 0, 11));
      branchCheckBox.setText("Display Branching History");
      branchCheckBox.setHorizontalTextPosition(SwingConstants.LEADING);
      branchCheckBox.setHorizontalAlignment(SwingConstants.RIGHT);
      branchCheckBox.setSelected(withBranching);
      detailPanel.add(branchCheckBox);

      actionsPanel.add(detailPanel, BorderLayout.NORTH);

      actionTextArea.setRows(10);
      actionTextArea.setEditable(false);
      actionTextArea.setFont(new Font("Dialog", 0, 11));
      actionTextArea.setBackground(new Color(212, 208, 200));
      actionTextArea.setPreferredSize(new Dimension(4, 150));
      actionTextArea.setBorder(new BevelBorder(BevelBorder.LOWERED));
      actionTextArea.setMargin(new Insets(2, 2, 2, 2));
      actionTextArea.setMinimumSize(new Dimension(4, 75));
      actionsPanel.add(actionTextArea, BorderLayout.CENTER);

      contentPanel.add(actionsPanel, BorderLayout.CENTER);

      changePanel.setLayout(new BorderLayout());

      changePanel.setPreferredSize(new Dimension(102, 175));
      changeLabelPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

      changeLabelPanel.setBorder(new EmptyBorder(new Insets(5, 1, 5, 1)));
      changeLabelPanel.setPreferredSize(new Dimension(102, 36));
      changeLabel.setText("Change Description");
      changeLabel.setForeground(Color.black);
      changeLabel.setFont(new Font("Dialog", 0, 11));
      changeLabelPanel.add(changeLabel);

      changePanel.add(changeLabelPanel, BorderLayout.NORTH);

      changeTextArea.setBackground(new Color(212, 208, 200));
      changeTextArea.setEditable(false);
      changeTextArea.setPreferredSize(new Dimension(52, 75));
      changeTextArea.setBorder(new BevelBorder(BevelBorder.LOWERED));
      changePanel.add(changeTextArea, BorderLayout.CENTER);

      contentPanel.add(changePanel, BorderLayout.SOUTH);

      getContentPane().add(contentPanel, BorderLayout.CENTER);

      closeButton.setFont(new Font("Dialog", 0, 11));
      closeButton.setText("Close");
      buttonPanel.add(closeButton);

      helpButton.setFont(new Font("Dialog", 0, 11));
      helpButton.setText("Help");
      buttonPanel.add(helpButton);

      getContentPane().add(buttonPanel, BorderLayout.SOUTH);

      viewButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { viewButtonActionPerformed(e); }
          });
      syncButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { syncButtonActionPerformed(e); }
          });
      diffRevsButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { diffRevsButtonActionPerformed(e); }
          });
      diffButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { diffButtonActionPerformed(e); }
          });
      describeButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { describeButtonActionPerformed(e); }
          });
      branchCheckBox.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { branchCheckBoxActionPerformed(e); }
          });
      closeButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { closeButtonActionPerformed(e); }
          });
      helpButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { helpButtonActionPerformed(e); }
          });

      pack();

      Dimension dimension = getContentPane().getSize();
      Dimension dimension1 = Toolkit.getDefaultToolkit().getScreenSize();
      setLocation((dimension1.width - dimension.width) / 2, (dimension1.height - dimension.height) / 2);
   } //GEN-END:initComponents

   /** Closes the dialog */
   private void closeDialog(WindowEvent evt)
   { //GEN-FIRST:event_closeDialog
      setVisible(false);
      dispose();
   } //GEN-LAST:event_closeDialog

   private void falsifyButtons()
   {
      viewButton.setEnabled(false);
      syncButton.setEnabled(false);
      diffButton.setEnabled(false);
      diffRevsButton.setEnabled(false);
      describeButton.setEnabled(false);
   }

private void enableButtons()
{
   viewButton.setEnabled(true);
   syncButton.setEnabled(true);
   diffButton.setEnabled(true);
   diffRevsButton.setEnabled(true);
   describeButton.setEnabled(true);
}

private String convertDriveLetter(String path)
{
   String driveLetter = path.substring(0,1);
   driveLetter = driveLetter.toUpperCase();
   return driveLetter + path.substring(1);
}
   public void viewButtonActionPerformed(ActionEvent e)
   {
      try
      {
         StringBuffer filePath = new StringBuffer();
         String rev = historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 0).toString();
         String fileName = (String)historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 1);
         filePath.append(fileName);
         filePath.append("#");
         filePath.append(rev);
         filePath.append(",#");
         filePath.append(rev);
         System.out.println(filePath);
         String outputFileName = IdeAccess.getIdeManager().getTempFile();
         System.out.println(outputFileName);
         FileEntry.print(env, filePath.toString(), outputFileName);
         File outputFile = new File(outputFileName);
         BufferedReader reader = new BufferedReader(new FileReader(outputFile));
         String line;
         StringBuffer output = new StringBuffer();
         while (null != (line = reader.readLine()))
         {
            output.append(line);
            output.append("\n");
         }
         JDialog myDialog = IdeWindowManagerAccess.getWindowManager().createDialog(null);
         DisplayDialog diffDialog = new DisplayDialog (myDialog, true, "File View " + fileName + "#" + rev, output.toString());
         Runner myRunner = new Runner(diffDialog);
         SwingUtilities.invokeLater(myRunner);         
      }
      catch (Exception exception)
      {
         messagepage.printMessage(IdeMessageType.ERROR, "<Perforce Provider>: syncButtonActionPerformed Exception " + exception);
      }    
   }

   public void syncButtonActionPerformed(ActionEvent e)
   {
      try
      {
         StringBuffer filePath = new StringBuffer();
         filePath.append((String)historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 1));
         filePath.append("#");
         filePath.append(historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 0).toString());
         FileEntry.syncWorkspace(env, filePath.toString());
      }
      catch (Exception exception)
      {
         messagepage.printMessage(IdeMessageType.ERROR, "<Perforce Provider>: syncButtonActionPerformed Exception " + exception);
      }  
   }

   public void diffRevsButtonActionPerformed(ActionEvent e) 
   { 
      Integer selected1 = (Integer)selected.get(0);
      Integer selected2 = (Integer)selected.get(1);
      String file1 = historyTable.getValueAt(selected1.intValue(), 1).toString() + "#" + historyTable.getValueAt(selected1.intValue(), 0).toString();
      String file2 = historyTable.getValueAt(selected2.intValue(), 1).toString() + "#" + historyTable.getValueAt(selected2.intValue(), 0).toString();

      JDialog myDialog = IdeWindowManagerAccess.getWindowManager().createDialog(null);
	   Diff2OptionsDialog diff2OptionsDialog = new Diff2OptionsDialog (myDialog, true, env, file1, file2);
	   Runner myRunner = new Runner(diff2OptionsDialog);
	   SwingUtilities.invokeLater(myRunner);
   }

   public void diffButtonActionPerformed(ActionEvent e) 
   { 
      try
      {
         JDialog myDialog = IdeWindowManagerAccess.getWindowManager().createDialog(null);
         String filePath = (String)historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 1);
         DiffOptionsDialog diffOptionsDialog = new DiffOptionsDialog (myDialog, true, env, filePath);
         diffOptionsDialog.setRevisionNumber(historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 0).toString());
         Runner myRunner = new Runner(diffOptionsDialog);
         SwingUtilities.invokeLater(myRunner);
      }
      catch (Exception exception)
      {
         messagepage.printMessage(IdeMessageType.ERROR, "<Perforce Provider>: diffButtonActionPerformed Exception " + exception);
      }   
   }

   public void describeButtonActionPerformed(ActionEvent e)
   {
      Integer changeNumber = (Integer)historyTable.getValueAt(rowSelectionModel.getMinSelectionIndex(), 2);    
      Change theChange = Change.getChange(getEnv(), changeNumber.intValue(), true);
      try
      {
         JDialog myDialog = IdeWindowManagerAccess.getWindowManager().createDialog(null);
         ChangeDescriptionDialog descriptionDialog = new ChangeDescriptionDialog (myDialog, true, theChange, getEnv());
         Runner myRunner = new Runner(descriptionDialog);
         SwingUtilities.invokeLater(myRunner);
      }
      catch (Exception exception)
      {
         messagepage.printMessage(IdeMessageType.ERROR,
             "<Perforce Provider>: describeButtonActionPerformed failed with exception\n" + exception.toString());
      }
   }

   public void branchCheckBoxActionPerformed(ActionEvent e)
   {
      withBranching = branchCheckBox.isSelected();
      String options = "-t";
      if (withBranching)
      {
         options = "-it";
      }      
      Vector history = FileEntry.getVerboseFileLog(getEnv(), fileName, options);
      historyTableModel = new FileEntryTableModel(history);
      sorter.setModel(historyTableModel);
      sorter.fireTableChanged(new TableModelEvent(sorter));
      rowSelectionModel.setSelectionInterval(0, 0);
   }

   public void closeButtonActionPerformed(ActionEvent e) { closeDialog(null); }

   public void helpButtonActionPerformed(ActionEvent e) { }

   private Env getEnv()
   {
      return env;
   }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private JPanel mainButtonPanel;
   private JButton viewButton;
   private JButton syncButton;
   private JButton diffRevsButton;
   private JButton diffButton;
   private JButton describeButton;
   private JPanel contentPanel;
   private JPanel tablePanel;
   private JTable historyTable;
   private JScrollPane tableScrollPane;
   private TableSorter historyTableSorter;
   private JPanel actionsPanel;
   private JPanel detailPanel;
   private JLabel actionsLabel;
   private JLabel fileTypeLabel;
   private JTextField fileTypeTextField;
   private JCheckBox branchCheckBox;
   private JTextArea actionTextArea;
   private JPanel changePanel;
   private JPanel changeLabelPanel;
   private JLabel changeLabel;
   private JTextArea changeTextArea;
   private JPanel buttonPanel;
   private JButton closeButton;
   private JButton helpButton;
   // End of variables declaration//GEN-END:variables

   private TableModel historyTableModel;
   private Env env;
   private String fileName;
   private FileEntry fileEntry;
   private boolean withBranching;
   private ListSelectionModel rowSelectionModel;
   private TableSorter sorter;
   private IdeMessagePage messagepage;
   private ArrayList selected;

   public class Runner implements Runnable
   {
      public JDialog dlg;

      public Runner(JDialog dlg)
      {
         this.dlg = dlg;
      }

      public void run()
      {
         dlg.show();
      }
   }
}
